//Spitlaser.cs

//audio
datablock AudioProfile(SpitlaserShotSound)
{
   filename    = "./SpitlaserFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SpitlaserEquipSound)
{
   filename    = "./SpitlaserEquip.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(SpitlaserHitSound)
{
   filename    = "./SpitlaserHit.wav";
   description = AudioClosest3d;
   preload = true;
};

//trail
datablock ParticleData(SpitlaserTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 100;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/chunk";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1 0.0 0.0 1";
	colors[1]	= "1 0.2 0.0 0.4";
	sizes[0]	= 0.15;
	sizes[1]	= 0.25;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(SpitlaserTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = SpitlaserTrailParticle;

   useEmitterColors = true;
   uiName = "";
};


//muzzle flash effects
datablock ParticleData(SpitlaserFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.0 0.0 0.9";
	colors[1]     = "0.4 0.0 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SpitlaserFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpitlaserFlashParticle";

   uiName = "";
};

datablock ParticleData(SpitlaserExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.6 0.5 0.5 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.5;

	useInvAlpha = true;
};
datablock ParticleEmitterData(SpitlaserExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpitlaserExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};


datablock ExplosionData(SpitlaserExplosion)
{
   //explosionShape = "";
	soundProfile = SpitlaserHitSound;

   lifeTimeMS = 150;

   particleEmitter = SpitlaserExplosionEmitter;
   particleDensity = 9;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.9 0.3 0.0";
   lightEndColor = "0 0 0";
};


AddDamageType("Spitlaser",   '<bitmap:add-ons/Weapon_Spitlaser/CI_Spitlaser> %1',    '%2 <bitmap:add-ons/Weapon_Spitlaser/CI_Spitlaser> %1',0.2,1);
datablock ProjectileData(SpitlaserProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 35;
   directDamageType    = $DamageType::Spitlaser;
   radiusDamageType    = $DamageType::Spitlaser;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 3;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 4;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse	  = 200;
   explosion           = SpitlaserExplosion;
   particleEmitter     = SpitlaserTrailEmitter;

   muzzleVelocity      = 80;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 4.0;
   lightColor  = ".75 0.2 0";

   uiName = "Spitlaser";
};

//////////
// item //
//////////
datablock ItemData(SpitlaserItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./spitlaser.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Spitlaser";
	iconName = "./icon_Spitlaser";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = SpitlaserImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SpitlaserImage)
{
   // Basic Item properties
   shapeFile = "./spitlaser.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = SpitlaserProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = False;
   colorShiftColor = SpitlaserItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.44;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= SpitlaserEquipSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.41;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= SpitlaserFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= SpitlaserShotSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";
	stateSequence[3]	= "Ready";

};

function SpitlaserImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}
